모든 Cloud-to-cloud 통합에는 사용자를 인증하는 메커니즘이 포함되어야 합니다.
인증을 사용하면 사용자의 Google 계정을 인증 시스템의 사용자 계정과 연결할 수 있습니다. 이를 통해 이행이 스마트 홈 인텐트를 수신할 때 사용자를 식별할 수 있습니다. Google 스마트 홈은 승인 코드 플로우가 있는 OAuth만 지원합니다.
이 페이지에서는 Cloud-to-cloud 통합과 호환되도록 OAuth 2.0 서버를 설정하는 방법을 설명합니다.
OAuth를 사용한 Google 계정 연결
승인 코드 흐름에는 두 개의 엔드포인트가 필요합니다.
아직 로그인하지 않은 사용자에게 로그인 UI를 표시하는 승인 엔드포인트 승인 엔드포인트는 요청된 액세스에 대한 사용자의 동의를 기록하기 위해 단기 승인 코드도 생성합니다.
두 가지 유형의 교환을 담당하는 토큰 교환 엔드포인트
- 승인 코드를 장기 갱신 토큰 및 단기 액세스 토큰으로 교환합니다. 이 교환은 사용자가 계정 연결 흐름을 진행할 때 발생합니다.
- 장기 갱신 토큰을 단기 액세스 토큰으로 교환합니다. 이 교환은 Google이 보유한 액세스 토큰이 만료되어 새 액세스 토큰이 필요할 때 발생합니다.
디자인 가이드라인
이 섹션에서는 OAuth 연결 흐름을 위해 호스팅하는 사용자 화면의 디자인 요구사항과 권장사항을 설명합니다. Google 앱에서 호출한 후 플랫폼은 사용자에게 Google 로그인 페이지와 계정 연결 동의 화면을 표시합니다. 사용자가 계정 연결에 동의하면 Google 앱으로 다시 리디렉션됩니다.
요구사항
- 사용자의 계정이 Google Home 또는 Google 어시스턴트와 같은 특정 Google 제품이 아닌 Google에 연결된다고 전달해야 합니다.
- '로그인하면 Google이 기기를 제어할 수 있도록 승인하는 것입니다.'와 같은 Google 승인 문구가 있어야 합니다. Google Home 개발자 정책의 Google 기기 제어 승인 섹션을 참고하세요.
- 웹 OAuth 연결 페이지를 열고 사용자 이름 및 비밀번호 필드와 같이 사용자가 Google 계정에 로그인할 수 있는 명확한 방법이 있는지 확인해야 합니다. 사용자가 웹 OAuth 연결 페이지로 이동하지 않고도 연결할 수 있는 Google 로그인 (GSI) 방법을 사용하지 마세요. 이는 Google 정책을 위반하는 것입니다.
- 사용자가 연결하는 통합을 나타내려면 OAuth 연결 페이지에 다음 항목 중 하나 이상을 포함해야 합니다.
- 회사 로고
- 회사 이름
- 통합 이름
- 앱 아이콘
권장사항
다음을 수행하는 것이 좋습니다.
Google 개인정보처리방침을 표시합니다. 동의 화면에 Google 개인정보처리방침 으로 연결되는 링크를 포함합니다.
공유할 데이터. 명확하고 간결한 언어를 사용하여 Google에 필요한 사용자 데이터와 그 이유, Google에서 공유할 수 있는 사용량 또는 상호작용 데이터를 사용자에게 알립니다.
명확한 클릭 유도문안. '동의 및 연결'과 같이 동의 화면에 명확한 클릭 유도문안을 명시합니다. 사용자가 계정을 연결하기 위해 Google과 공유해야 하는 데이터를 이해해야 하기 때문입니다.
취소 기능. 연결하지 않기로 선택한 경우 사용자가 돌아가거나 취소할 수 있는 방법을 제공합니다.
명확한 로그인 절차. 사용자가 Google 계정에 로그인할 수 있는 명확한 방법이 있는지 확인합니다. 예를 들어 사용자 이름 및 비밀번호 필드 또는 Google로 로그인과 같은 방법이 있습니다.
연결 해제 기능. 플랫폼의 계정 설정 URL과 같이 사용자가 연결 해제할 수 있는 메커니즘을 제공합니다. 또는 사용자가 연결된 계정을 관리할 수 있는 Google 계정으로 연결되는 링크를 포함할 수 있습니다. 사용자가 통합에서 연결 해제하는 경우
agentUsers.delete를 사용하여 Google에 변경사항을 알립니다.사용자 계정 변경 기능. 사용자가 계정을 전환할 수 있는 방법을 제안합니다. 사용자가 여러 계정을 보유하는 경향이 있는 경우 특히 유용합니다.
- 사용자가 계정을 전환하기 위해 동의 화면을 닫아야 하는 경우 사용자가 OAuth 연결을 사용하여 원하는 계정에 로그인할 수 있도록 복구 가능한 오류를 Google에 전송합니다.
로고를 포함합니다. 동의 화면에 회사 로고를 표시합니다. 스타일 가이드라인에 따라 로고를 배치합니다. Google 로고도 표시하려면 로고 및 상표를 참고하세요.
승인 코드 플로우
An OAuth 2.0 server implementation of the authorization code flow consists of two endpoints, which your service makes available by HTTPS. The first endpoint is the authorization endpoint, which is responsible for finding or obtaining consent from users for data access. The authorization endpoint presents a sign-in UI to your users that aren't already signed in and records consent to the requested access. The second endpoint is the token exchange endpoint, which is used to obtain encrypted strings, called tokens, that authorize a user to access your service.
When a Google application needs to call one of your service's APIs, Google uses these endpoints together to get permission from your users to call these APIs on their behalf.
An OAuth 2.0 authorization code flow session initiated by Google has the following flow:
- Google opens your authorization endpoint in the user's browser. If the flow started on a voice-only device for an Action, Google transfers the execution to a phone.
- The user signs in, if not signed in already, and grants Google permission to access their data with your API, if they haven't already granted permission.
- Your service creates an authorization code and returns it to Google. To do so, redirect the user's browser back to Google with the authorization code attached to the request.
- Google sends the authorization code to your token exchange endpoint, which verifies the authenticity of the code and returns an access token and a refresh token. The access token is a short-lived token that your service accepts as credentials to access APIs. The refresh token is a long-lived token that Google can store and use to acquire new access tokens when they expire.
- After the user has completed the account linking flow, every subsequent request sent from Google contains an access token.
Handle authorization requests
When you need to perform account linking using the OAuth 2.0 authorization code flow, Google sends the user to your authorization endpoint with a request that includes the following parameters:
| Authorization endpoint parameters | |
|---|---|
client_id |
The Client ID you assigned to Google. |
redirect_uri |
The URL to which you send the response to this request. |
state |
A bookkeeping value that is passed back to Google unchanged in the redirect URI. |
scope |
Optional: A space-delimited set of scope strings that specify the data Google is requesting authorization for. |
response_type |
The type of value to return in the response. For the OAuth 2.0
authorization code flow, the response type is always code.
|
For example, if your authorization endpoint is available at
https://myservice.example.com/auth, a request might look like the following:
GET https://myservice.example.com/auth?client_id=GOOGLE_CLIENT_ID&redirect_uri=REDIRECT_URI&state=STATE_STRING&scope=REQUESTED_SCOPES&response_type=code
For your authorization endpoint to handle sign-in requests, do the following steps:
- Verify that the
client_idmatches the Client ID you assigned to Google, and that theredirect_urimatches the redirect URL provided by Google for your service. These checks are important to prevent granting access to unintended or misconfigured client apps. If you support multiple OAuth 2.0 flows, also confirm that theresponse_typeiscode. - Check if the user is signed in to your service. If the user isn't signed in, complete your service's sign-in or sign-up flow.
- Generate an authorization code for Google to use to access your API. The authorization code can be any string value, but it must uniquely represent the user, the client the token is for, and the code's expiration time, and it must not be guessable. You typically issue authorization codes that expire after approximately 10 minutes.
- Confirm that the URL specified by the
redirect_uriparameter has the following form:https://oauth-redirect.googleusercontent.com/r/YOUR_PROJECT_ID https://oauth-redirect-sandbox.googleusercontent.com/r/YOUR_PROJECT_ID
- Redirect the user's browser to the URL specified by the
redirect_uriparameter. Include the authorization code you just generated and the original, unmodified state value when you redirect by appending thecodeandstateparameters. The following is an example of the resulting URL:https://oauth-redirect.googleusercontent.com/r/YOUR_PROJECT_ID?code=AUTHORIZATION_CODE&state=STATE_STRING
Handle token exchange requests
Your service's token exchange endpoint is responsible for two kinds of token exchanges:
- Exchange authorization codes for access tokens and refresh tokens
- Exchange refresh tokens for access tokens
Token exchange requests include the following parameters:
| Token exchange endpoint parameters | |
|---|---|
client_id |
A string that identifies the request origin as Google. This string must be registered within your system as Google's unique identifier. |
client_secret |
A secret string that you registered with Google for your service. |
grant_type |
The type of token being exchanged. It's either
authorization_code or refresh_token. |
code |
When grant_type=authorization_code, this parameter is the
code Google received from either your sign-in or token exchange
endpoint. |
redirect_uri |
When grant_type=authorization_code, this parameter is the
URL used in the initial authorization request. |
refresh_token |
When grant_type=refresh_token, this parameter is the
refresh token Google received from your token exchange endpoint. |
Configure how Google sends credentials to your server
Depending on its implementation, your authorization server expects to receive client credentials either in the request body, or in the request header.
By default, Google sends the credentials in the request body. If your authorization server requires the client credentials to be in the request header, you must configure your Cloud-to-cloud integration accordingly:
From the list of projects, click Open next to the project you want to work with.
Under Cloud-to-Cloud, select Develop.
Click Open next your integration.
Scroll down to the Permissions (optional) section and select the Have Google transmit Client ID and secret via HTTP basic auth header checkbox.
Click Save to save your changes.
Exchange authorization codes for access tokens and refresh tokens
After the user signs in and your authorization endpoint returns a short-lived authorization code to Google, Google sends a request to your token exchange endpoint to exchange the authorization code for an access token and a refresh token.
For these requests, the value of grant_type is authorization_code, and the
value of code is the value of the authorization code you previously granted
to Google. The following is an example of a request to exchange an
authorization code for an access token and a refresh token:
POST /token HTTP/1.1 Host: oauth2.example.com Content-Type: application/x-www-form-urlencoded client_id=GOOGLE_CLIENT_ID&client_secret=GOOGLE_CLIENT_SECRET&grant_type=authorization_code&code=AUTHORIZATION_CODE&redirect_uri=REDIRECT_URI
To exchange authorization codes for an access token and a refresh token, your
token exchange endpoint responds to POST requests by executing the following
steps:
- Verify that the
client_ididentifies the request origin as an authorized origin, and that theclient_secretmatches the expected value. - Verify that the authorization code is valid and not expired, and that the client ID specified in the request matches the client ID associated with the authorization code.
- Confirm that the URL specified by the
redirect_uriparameter is identical to the value used in the initial authorization request. - If you can't verify all of the above criteria, return an HTTP
400 Bad Request error with
{"error": "invalid_grant"}as the body. - Otherwise, use the user ID from the authorization code to generate a refresh token and an access token. These tokens can be any string value, but they must uniquely represent the user and the client the token is for, and they must not be guessable. For access tokens, also record the expiration time of the token, which is typically an hour after you issue the token. Refresh tokens don't expire.
- Return the following JSON object in the body of the HTTPS response:
{ "token_type": "Bearer", "access_token": "ACCESS_TOKEN", "refresh_token": "REFRESH_TOKEN", "expires_in": SECONDS_TO_EXPIRATION }
Google stores the access token and the refresh token for the user and records the expiration of the access token. When the access token expires, Google uses the refresh token to get a new access token from your token exchange endpoint.
Exchange refresh tokens for access tokens
When an access token expires, Google sends a request to your token exchange endpoint to exchange a refresh token for a new access token.
For these requests, the value of grant_type is refresh_token, and the value
of refresh_token is the value of the refresh token you previously granted to
Google. The following is an example of a request to exchange a refresh token
for an access token:
POST /token HTTP/1.1 Host: oauth2.example.com Content-Type: application/x-www-form-urlencoded client_id=GOOGLE_CLIENT_ID&client_secret=GOOGLE_CLIENT_SECRET&grant_type=refresh_token&refresh_token=REFRESH_TOKEN
To exchange a refresh token for an access token, your token exchange endpoint
responds to POST requests by executing the following steps:
- Verify that the
client_ididentifies the request origin as Google, and that theclient_secretmatches the expected value. - Verify that the refresh token is valid, and that the client ID specified in the request matches the client ID associated with the refresh token.
- If you can't verify all of the above criteria, return an HTTP 400
Bad Request error with
{"error": "invalid_grant"}as the body. - Otherwise, use the user ID from the refresh token to generate an access token. These tokens can be any string value, but they must uniquely represent the user and the client the token is for, and they must not be guessable. For access tokens, also record the expiration time of the token, typically an hour after you issue the token.
- Return the following JSON object in the body of the HTTPS
response:
{ "token_type": "Bearer", "access_token": "ACCESS_TOKEN", "expires_in": SECONDS_TO_EXPIRATION }
Handle userinfo requests
The userinfo endpoint is an OAuth 2.0 protected resource that return claims about the linked user. Implementing and hosting the userinfo endpoint is optional, except for the following use cases:
- Linked Account Sign-In with Google One Tap.
- Frictionless subscription on AndroidTV.
After the access token has been successfully retrieved from your token endpoint, Google sends a request to your userinfo endpoint to retrieve basic profile information about the linked user.
| userinfo endpoint request headers | |
|---|---|
Authorization header |
The access token of type Bearer. |
For example, if your userinfo endpoint is available at
https://myservice.example.com/userinfo, a request might look like the following:
GET /userinfo HTTP/1.1 Host: myservice.example.com Authorization: Bearer ACCESS_TOKEN
For your userinfo endpoint to handle requests, do the following steps:
- Extract access token from the Authorization header and return information for the user associated with the access token.
- If the access token is invalid, return an HTTP 401 Unauthorized error with using the
WWW-AuthenticateResponse Header. Below is an example of a userinfo error response: If a 401 Unauthorized, or any other unsuccessful error response is returned during the linking process, the error will be non-recoverable, the retrieved token will be discarded and the user will have to initiate the linking process again.HTTP/1.1 401 Unauthorized WWW-Authenticate: error="invalid_token", error_description="The Access Token expired"
If the access token is valid, return and HTTP 200 response with the following JSON object in the body of the HTTPS response:
If your userinfo endpoint returns an HTTP 200 success response, the retrieved token and claims are registered against the user's Google account.{ "sub": "USER_UUID", "email": "EMAIL_ADDRESS", "given_name": "FIRST_NAME", "family_name": "LAST_NAME", "name": "FULL_NAME", "picture": "PROFILE_PICTURE", }userinfo endpoint response subA unique ID that identifies the user in your system. emailEmail address of the user. given_nameOptional: First name of the user. family_nameOptional: Last name of the user. nameOptional: Full name of the user. pictureOptional: Profile picture of the user.